#include "fits.h"

namespace FITS = SAOTrace::IO::FITS ;

template <> const int FITS::Column<double>::_type         = TDOUBLE;
template <> const int FITS::Column<float>::_type          = TFLOAT;
template <> const int FITS::Column<int>::_type            = TINT;
template <> const int FITS::Column<long>::_type           = TLONG;
template <> const int FITS::Column<short>::_type          = TSHORT;
template <> const int FITS::Column<unsigned int>::_type   = TUINT;
template <> const int FITS::Column<unsigned long>::_type  = TULONG;
template <> const int FITS::Column<unsigned short>::_type = TUSHORT;

bool
FITS::cmp_shape( FITS::Extent& a0, FITS::Extent& b0 ) {

    Extent a = a0;
    Extent b = b0;

    Extent::iterator a_end = remove( a.begin(), a.end(), 1 );
    Extent::iterator b_end = remove( b.begin(), b.end(), 1 );

    a.resize( a_end - a.begin() );
    b.resize( b_end - b.begin() );

    return a == b;
}

long FITS::read_table_columns(const std::string& file, std::vector<FITS::ColumnBase*>& columns) {

    return FITS::TableFH(file).read_table_columns( columns );

}
