// -*-c++-*-

#ifndef COLUMN_FITS_H
#define COLUMN_FITS_H

#include <boost/serialization/vector.hpp>

#include <saotrace/io/fits/fits.h>

namespace FITSTest {

    struct Column {

	// value of last column used
	static int col_counter;

	string name;
	string form;
	int   colno;
	int   repeat;
	SAOTrace::IO::FITS::Extent extent;
	string dimstr;
	string dimkey;

	int minval;
	int maxval;

	Column() {}

	Column( const char* name, const char* form_code, int i = 0, int j = 0, int k = 0);

	int write( fitsfile* fptr, int nrows, int *status );

	template<class Archive>
	void serialize( Archive & ar, const unsigned int version ) {
	    ar & name ;
	    ar & form  ;
	    ar & colno ;
	    ar & minval;
	    ar & maxval;
	    ar & extent;
	    ar & repeat;
	}

	typedef vector<Column> MetaData;
	typedef map<string,Column*> MetaMap;

	static void read_meta ( const string&filename, MetaData& meta_data, MetaMap& meta_map);

    };


}


#endif // ! COLUMN_FITS_H
